Subject: bug#31276: 27.0.50; "Spurious" empty first line from before-string

From: Stefan Monnier <[email-masked]>
Date: Sat, 28 Apr 2018 09:13:18 -0400

>>     % src/emacs -Q etc/NEWS --eval '(let ((ol (make-overlay (+ (point) 10)
>> (+ (point) 10)))) (overlay-put ol (quote before-string) "\nhello\n"))'
>>     C-u 1 C-v
>> You should see that the "scroll by 1 line" didn't actually scroll: it just
>> removed the "GNU Emacs " from your sight and left an empty line instead.
> After "C-u 1 C-v", type C-p, then type "C-u 1 C-v" again.  What do you
> see?

I see the display go

    GNU Emacs

    hello
    NEWS ...

i.e. I get a *really* spurious line.  This one is clearly a bug.

> Does what you see change your idea about where the bug is?

Not really, but it's probably because my idea of "where the bug is" is
much too vague.

>> Whether you consider this as a bug report or a feature request, my point
>> is that when the window starts with a before/after-string and that
>> string starts with a line-feed, we should skip that line-feed rather
>> than waste a perfectly good line.
> I don't understand: are you arguing that we should ignore newlines in
> overlay strings when they happen to appear at the beginning of the
> window?

Not "in" but "at the beginning of", yes.  Also I'd probably go with
"newline" rather than "newlines", just out of conservatism.

> It sounds very strange to me to do so.

That was also my first reaction, but redisplay can arguably choose (to
some extent) at which line it starts the display, so if you skip some
leading newline you still get a valid result.  The "to some extent" is
because sometimes the redisplay can't really choose (i.e. when
window-start has been fixed), but in the current case, even if
window-start is fixed there are several possible choices of "first line"
to display, so even in that case the result is still valid.

> Whoever puts the newlines there does that for a reason,

To divide the (previous) line, but not to introduce an empty line.

> and I'm sure will object to having them effectively removed in
> some situations.

I put the newlines there and I definitely would not object.
Better yet, I'd report a bug if the newline isn't removed.

        Stefan